format long
warning off MATLAB:divideByZero;
clear figure;
clear z;
clear y;
clear r;

%fin=fopen('/Users/daves/Desktop/Intercomparison/RAOB/inputfile');
fin=fopen('/home/rdworak/Intercomp/scr/inputfile');
inputfile=fgetl(fin)

%y=load(inputfile);

%z=load('/home/rdworak/Intercomp/RAOBs/convraob.txt');
z=dlmread('/home/rdworak/Intercomp/RAOBs/convraob.txt','',1,0);
%convert sign of lon for raobs to Mcidas notation + west, - east
z(:,2)=z(:,2)*-1;
distthres=150;
%qithres=50;
%qithres=80;

for qithres=50:30:80

clear r;

    for qitype=18:1:19
    %qitype=17
        y=dlmread(inputfile,';',1,0);
	%y=dlmread(inputfile,'');
    %qitype=19
%y=y(find(y(:,19) >= qithres), :); %For CQI
%y=y(find(y(:,18) >= qithres), :); %For QIF
%y=y(find(y(:,17) >= qithres), :);  %For QINF
y=y(find(y(:,qitype) >= qithres), :);

k=0;
r=zeros(k,9);
sz=size(z,1);
sy=size(y,1);
for j=1:sy
    pdiffmin=100;
    for i=1:sz
        latdis=111*abs(z(i,1)-y(j,2));
        if latdis<=distthres
            angle=abs(cos(deg2rad(z(i,1))));
            londif=abs(z(i,2)-y(j,3));
            if londif<=180
                londis=londif*angle*111;
            else
                londis=(360-londif)*angle*111;
            end
            disp =sqrt(latdis^2+londis^2);
                if disp<=distthres
                   pdiff=y(j,8)-z(i,3);
                    if abs(pdiff)<=abs(pdiffmin)
                        %Include RAOB Sanity Check
                        %if (z(i,3)>=200 && z(i,3)<=1000) && (z(i,5)>=0 && z(i,5)<=360) && (z(i,6)>0 && z(i,6)<=200)
                       % if (z(i,3)>=700)
                        tdiff=0;                        
                        ddiff=abs(y(j,7)-z(i,5));
                        if ddiff>180
                            ddiff=360-ddiff;
                            if z(i,5)<y(j,7)
                                ddiff=-1*ddiff;
                            end
                        else
                            if z(i,5)>y(j,7)
                                ddiff=-1*ddiff;
                            end
                        end
                        mdiff=(y(j,6))-(z(i,6));
                        su=y(j,6)*sin(deg2rad(y(j,7)));
                        sv=y(j,6)*cos(deg2rad(y(j,7)));
                        ru=z(i,6)*sin(deg2rad(z(i,5)));
                        rv=z(i,6)*cos(deg2rad(z(i,5)));
                        UD=su-ru;
                        VD=sv-rv;
                        vdiff=sqrt(UD^2+VD^2);
                        pdiffmin=pdiff;
                        c=i;
                        
                   % end  
                end  
                  end
              end 
          end 
          if abs(pdiffmin)<=50
              k=k+1;
              r(k,1)=pdiffmin;
              r(k,2)=tdiff;
              r(k,3)=ddiff;
              r(k,4)=mdiff;
              r(k,5)=vdiff;
              r(k,6)=UD;
              r(k,7)=VD;
              r(k,8)=c;
              r(k,9)=j;
          end
      end

 
r;
k
pbias=sum(r(:,1))/k
tbias=sum(r(:,2))/k
dbias=sum(r(:,3))/k
mbias=sum(r(:,4))/k
vbias=sqrt((sum(r(:,6))/k)^2+(sum(r(:,7))/k)^2)
    
prms=sqrt((sum((r(:,1).^2)))/k)
trms=sqrt((sum((r(:,2).^2)))/k)
drms=sqrt((sum((r(:,3).^2)))/k)
mrms=sqrt((sum((r(:,4).^2)))/k)
vrms=sqrt((sqrt(sum((r(:,6)).^2)/k))^2+(sqrt(sum((r(:,7)).^2)/k))^2)


if (qithres==50)&&(qitype==17)
fid1 = fopen('/data/rdworak/Intercomp/Output2018/Raobdiff/exp22/raob.output_ALL_50QINF_McIcor','a');
%fprintf(fid,'FILE   Samples   Pbias   Prms   Sbias   Srms  Dbias  VRMS\n');
fprintf(fid1,'%40s, %9.0f, %9.2f, %9.2f, %9.2f, %9.2f, %9.2f, %9.2f\n',inputfile,k,pbias,prms,mbias,mrms,dbias,vrms);
fclose(fid1);
end

if (qithres==80)&&(qitype==17)
fid2=fopen('/data/rdworak/Intercomp/Output2018/Raobdiff/exp22/raob.output_ALL_80QINF_McIcor','a');
fprintf(fid2,'%40s, %9.0f, %9.2f, %9.2f, %9.2f, %9.2f, %9.2f, %9.2f\n',inputfile,k,pbias,prms,mbias,mrms,dbias,vrms);
fclose(fid2);
end


if (qithres==50)&&(qitype==18)
fid3=fopen('/data/rdworak/Intercomp/Output2018/Raobdiff/exp22/raob.output_ALL_50QIF_McIcor','a');
fprintf(fid3,'%40s, %9.0f, %9.2f, %9.2f, %9.2f, %9.2f, %9.2f, %9.2f\n',inputfile,k,pbias,prms,mbias,mrms,dbias,vrms);
fclose(fid3);
end

if (qithres==80)&&(qitype==18)
fid4=fopen('/data/rdworak/Intercomp/Output2018/Raobdiff/exp22/raob.output_ALL_80QIF_McIcor','a');
fprintf(fid4,'%40s, %9.0f, %9.2f, %9.2f, %9.2f, %9.2f, %9.2f, %9.2f\n',inputfile,k,pbias,prms,mbias,mrms,dbias,vrms);
fclose(fid4);
end

if (qithres==50)&&(qitype==19)
fid5=fopen('/data/rdworak/Intercomp/Output2018/Raobdiff/exp22/raob.output_ALL_50CQI_McIcor','a');
fprintf(fid5,'%40s, %9.0f, %9.2f, %9.2f, %9.2f, %9.2f, %9.2f, %9.2f\n',inputfile,k,pbias,prms,mbias,mrms,dbias,vrms);
fclose(fid5);
end

if (qithres==80)&&(qitype==19)
fid6=fopen('/data/rdworak/Intercomp/Output2018/Raobdiff/exp22/raob.output_ALL_80CQI_McIcor','a');
fprintf(fid6,'%40s, %9.0f, %9.2f, %9.2f, %9.2f, %9.2f, %9.2f, %9.2f\n',inputfile,k,pbias,prms,mbias,mrms,dbias,vrms);
fclose(fid6);
end
    end
end
% 
% fid = fopen('/home/sarahl/rms.output','a');
% fprintf(fid,'%9.0f %9.2f %9.2f %9.2f %9.2f %9.2f\n',k,prms,trms,drms,mrms,vrms);
% fclose(fid);

%fid = fopen('/home/sarahl/diff.output','w');
%for h=1:k
%fprintf(fid,'%9.0f %9.0f %9.0f %9.2f %9.2f %9.2f %9.2f %9.2f\n',h,r(h,8),r(h,9),r(h,1),r(h,2),r(h,3),r(h,4),r(h,5));
%end
%fclose(fid);


% 
% fid = fopen('/home/sarahl/bias.output','a');
% fprintf(fid,'%9.0f %9.2f %9.2f %9.2f %9.2f\n',k,pbias,tbias,dbias,mbias);
% fclose(fid);
% 
% fid = fopen('/home/sarahl/rms.output','a');
% fprintf(fid,'%9.0f %9.2f %9.2f %9.2f %9.2f\n',k,prms,trms,drms,mrms);
% fclose(fid);

% figure(1)
% bin=[-20:1:20];
% h1=histc(r(:,4),bin);
% bar(bin, h1,'histc');
% ylabel('Frequency');
% xlabel('Mag diff');
% title('Frequencey of mag diff of prediced winds within dist thres to closest raob level');
